openapi: 3.0.0
info:
  title: Product Catalog
  description: >-
    As brands and retailers grow, they often expand their item catalogs,
    resulting in the need to enrich and manage more product (commonly referred
    to as item in fabric) data. fabric Product Catalog alleviates the burden of managing large amounts of item data by
    means of a central storage repository. fabric Product Catalog helps you with improved
    data quality, consistent customer experience, reduced time to market, easy
    integration with external systems, reduced management costs and risks,
    faster and easier updates, and easy scaling. You can create, import, enrich,
    validate, distribute, and manage complex item information, centrally. As a
    result, you deliver product experiences that drive sales through every
    channel. <br /> <br /> During onboarding, you are given the necessary
    credentials to access Product Catalog - Copilot UI, APIs, or both. As a prerequisite,
    you create the items to be sold, identify their unique as well as common
    properties, and envision their organization into categories and sub
    categories. A basic workflow is: <br /> 1) **Create item attributes** using
    POST /api-product/v1/product/attribute/bulk. <br /> 2) **Update attribute
    mapping** using POST /api-product/v1/product/attribute/mapping <br /> 3)
    **Create Primary category** using the POST /api-category/v1/category to
    create the original organizational structure. <br /> 4) **Assign item
    attributes** to Primary category using POST
    /api-category/v1/category/item-attribute. <br /> 5) **Create items** using
    POST /api-product/v1/product/bulk/insert. <br /> 6) **Create Alternate
    category**, for distribution management and fulfilling various merchandising
    objectives.
  version: 2.0.0
  contact:
    email: support@fabric.inc
  license:
    name: fabric API License
    url: https://fabric.inc/api-license
tags:
  - name: Category
    description: >-
      Categories (also called hierarchies or nodes) are hierarchical structures
      to organize items and services into intuitive groups. Organizing items in
      this way simplifies item discovery and lifecycle management. There are two
      types of categories - **Primary** and **Alternate**. They enable you to
      create, organize, and distribute item data.  - Primary category is the
      original catalog tree with nested levels of categories that place each
      item where it belongs, within a category. For example, `Computers` is a
      parent category with `Laptops` and `Desktops` as children categories, and
      `MacBook Pro` is an item within `Laptops`. This organization can be
      represented as Computers > Laptops > MacBook Pro.  - Alternate categories
      serve as alternate organizations of the Primary category. Their main
      purpose is distribution management by displaying items on your website
      based on separate browsing structure configurations you set to help you
      achieve various merchandizing objectives, such as organizational
      requirements, multi-regional assortments, multi-channel assortments, and
      collections. For example, a company that sells, repairs, and supports
      computers and related items and services will have a Primary category
      containing a full list of their SKUs. However, this Primary category is
      not granular enough to use on their storefront. Hence, multiple Alternate
      hierarchies are created to target specific shopper segment experiences.
      For laptop consumers they'll have one Alternate category, which lists all
      the laptops and PCs. For large businesses they'll have  another Alternate
      category, which lists all commercial laptops, PCs, printers, and servers.
      Both of the Alternate categories act as filters of the Primary category,
      tailored to the purpose of that merchandising strategy.  **Category**, a
      subset of Product Catalog endpoints, aims to simplify catalog management by letting
      you create, update, and get one or more categories, category attributes,
      and item attributes. In addition, you can add and update category sources,
      source exclusions, and item attribute conditions.   **Note**: The root
      name of primary category is PRIMARY, and it cannot be changed.
  - name: Product
    description: >-
      **Product**, a subset of Product Catalog endpoints, aims at making item management
      more efficient. They create, update, and get items, which may be
      individual items or collection of items (called bundles). Each item has a
      title, item ID, description, category, and assigned attributes. Multiple
      options of a given item become variants of that item. For example, a
      t-shirt with three sizes may have small, medium, and large variants. Each
      variant has its own item ID, attributes, and other data points. Each
      variant is nested under its parent item, allowing the different options to
      appear on the same product page. You can also create or update one or more
      item attributes and attribute groups.
  - name: Attributes
    description: >-
      Item attributes are the objective and factual descriptions of items that
      shoppers see when they browse through your site. Attributes may be
      technical specifications like size, weight, etc., design specifications
      like color, material, etc., or basic specifications like name,
      description, and ID. Ites attributes are crucial as they directly
      influence purchasing decisions. Complete and correct item information help
      shoppers narrow down their search and filter items with minimal cognitive
      load.
  - name: Bulk Import
    description: >-
      Set of endpoints to help bulk import of items, bundles, categories and
      attributes through CSV files
externalDocs:
  description: Find out more about Product Catalog
  url: /v3/product-catalog/user-guides/product-catalog/overview
servers:
  - url: https://live.copilot.fabric.inc
    description: Production
paths:
  /api-category/v1/category:
    post:
      tags:
        - Category
      summary: Create category
      description: >-
        Creates Primary or Alternate category to organize items into logical
        groups. <br /> **Note**: <br /> 1) To add **Primary**  category, only
        `name` is required in the request. <br /> 2) To add a **child**
        category, both `name` and `parentNodeId` are required. For **child**
        category, you can additionally specify `order` of display. <br /> 3) To
        add an **Alternate** category, both `name` and `type` are required. <br
        /> **Note**: Category details including category ID received in the
        response are required for subsequent calls. For example, it's required
        to *Create item* (POST /v1/product/bulk/insert).
      operationId: categoryCreate
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/CreateCategoryRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ModifyCategory"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
    get:
      tags:
        - Category
      summary: Get categories
      description: >-
        Gets categories and their details including attributes, breadcrumbs, and
        details of children categories. <br /> **Note**: <br /> 1) Specify
        either `ids` or `nodeIds` to get specific categories. <br /> 2) Use
        `type` to get a specific category type. <br /> 3) When query parameters
        are omitted, this endpoint returns a paginated response listing all
        Alternate categories in Active status. Using the query parameters `size`
        and `page`, you can narrow down the search results.
      operationId: getCategoriesById
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: ids
          description: >-
            A 24-character system-generated category IDs. If `ids` and `nodeIds`
            are omitted, this endpoint returns all Alternate categories in
            Active status. Using `size` and `page`, you can narrow down the
            search results.
          example:
            - 6196b45b5cb04b7ce167cb46
            - 7196b45b5cb04b7ce167cb45
          explode: false
          schema:
            type: array
            items:
              type: string
        - in: query
          name: nodeIds
          description: >-
            Numeric category IDs. When `ids` and `nodeIds` are omitted, specify
            `size` and `page` to narrow down the search results.
          example:
            - 123
            - 234
          explode: false
          schema:
            type: array
            items:
              type: number
        - in: query
          name: keyword
          description: >-
            Keywords to search for categories. You will get a pagination
            response. Using `size` and `page`, you can narrow down the search
            results.
          example: computers
          schema:
            type: string
        - in: query
          name: type
          description: >-
            Category type. <br /> **Note**: When omitted, you will get
            `ALTERNATE` categories by default.
          schema:
            type: string
            enum:
              - PRIMARY
              - ALTERNATE
              - ALL
            example: ALL
        - in: query
          name: status
          description: >-
            Category status. <br /> **Note**: If omitted, you will get Alternate
            categories in Active status by default. <br /> **Note**: When `type`
            is Primary, `status` must be Active. Inactive status is not
            applicable for Primary category.
          schema:
            type: string
            enum:
              - ACTIVE
              - INACTIVE
              - ALL
            example: ALL
        - $ref: "#/components/parameters/Page"
        - $ref: "#/components/parameters/Size"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CategoryPage"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/{nodeId}:
    put:
      tags:
        - Category
      summary: Modify category
      description: >-
        Updates category details such as name, parent, and its order of
        appearance amongst sibling categories.
      operationId: categoryModify
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: path
          name: nodeId
          required: true
          description: Numeric category ID
          example: 1204
          schema:
            type: number
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ModifyCategoryRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ModifyCategory"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/search:
    get:
      tags:
        - Category
      summary: Find categories
      description: >-
        Finds categories, by keywords, category identifiers, type, or status.
        <br /> **Note**: <br /> 1) Categories and children categories must
        already exist in the system. <br /> 2) When query parameters are
        omitted, this endpoint returns a paginated response with all the
        categories. Using `size` and `page`, you can narrow down the search
        results. <br /> 3) GET /v1/category (Store admin context) or Algolia
        search (Shopper context) is strongly recommended over this endpoint.
      operationId: searchCategories
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: keyword
          description: >-
            Keywords to search for categories. The response is paginated. Using
            query parameters `page` and `size`, you can narrow down the search
            results.
          example: computers
          schema:
            type: string
        - in: query
          name: ids
          description: >-
            A 24-characters system-generated category IDs. If `ids` and
            `nodeIds` are omitted, this endpoint returns a paginated response.
            Using query parameters `page` and `size`, you can narrow down the
            search results.
          example:
            - 6196b45b5cb04b7ce167cb46
            - 7196b45b5cb04b7ce167cb47
          explode: false
          schema:
            type: array
            items:
              type: string
        - in: query
          name: nodeIds
          description: >-
            Numeric category IDs. If `ids` and `nodeIds` are omitted, this
            endpoint returns a paginated response. Using query parameters `page`
            and `size`, you can narrow down the search results.
          example:
            - 15
            - 16
          explode: false
          schema:
            type: array
            items:
              type: number
        - in: query
          name: type
          description: >-
            Category type. <br /> **Note**: If omitted, you will get a paginated
            response with `ALL` categories. Using query parameters `page` and
            `size`, you can narrow down the search results.
          schema:
            type: string
            enum:
              - PRIMARY
              - ALTERNATE
              - ALL
            example: ALL
        - in: query
          name: status
          description: >-
            Category status. If omitted, you will get a paginated response of
            categories in `ACTIVE` status. Using the query parameters `page` and
            `size`, you can narrow down the search results. <br /> **Note**:
            When `type` is Primary, `status` must be Active. Inactive status is
            not applicable for Primary category.
          schema:
            type: string
            enum:
              - ACTIVE
              - INACTIVE
              - ALL
            example: ALL
        - $ref: "#/components/parameters/Page"
        - $ref: "#/components/parameters/Size"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CategoryPage"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/tree:
    get:
      tags:
        - Category
      summary: Get category tree
      description: >-
        Hierarchy of parent and children categories form a tree structure. This
        endpoint returns a tree of categories rooted in the category identified
        by `id` or `nodeId`.<br /> **Note**: <br /> 1) If parent category does
        not exist in the system, you'll get a `404 - Not found` error <br /> 2)
        If a child category does not exist for the given parent, you'll get a
        success response but `children` property will show a blank array.
      operationId: getCategoryTree
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: id
          description: >-
            A 24-character system-generated ID of root category. Either `id` or
            `nodeId` must be specified.
          example: 6196b44a5cb04b7ce167cb34
          schema:
            type: string
        - in: query
          name: nodeId
          description:
            Numeric category ID. Either `id` or `nodeId` must be specified.
          example: 12
          schema:
            type: integer
        - in: query
          name: depth
          description: >-
            Limits the size of the hierarchical category tree returned in the
            response. Depth of 0 means no children categories, attributes, or
            breadcrumbs, are included in the response. Unless depth is
            specified, entire category is returned up to the last set of
            categories (that have no more children categories).
          example: 1
          schema:
            type: number
        - in: query
          name: excludeAttributes
          description: >-
            Set `true` to exclude attributes from both parent and children
            objects or false to include attributes in both parent and children
            details. <br /> The default setting false.
          example: true
          schema:
            type: boolean
        - in: query
          name: excludeBreadcrumbs
          description: >-
            Set `true` to exclude breadcrumbs from both parent and children
            objects or false to include breadcrumbs in both parent and children
            details. <br /> The default setting false.
          example: true
          schema:
            type: boolean
        - in: query
          name: excludeItemIds
          description: >-
            Set `true` to exclude item IDs from both parent and children objects
            or false to include item IDs in both parent and children details.
            <br /> The default setting false.
          example: true
          schema:
            type: boolean
        - in: query
          name: onlyIncludeAttributes
          description: >-
            Attributes are included based on their exact, case-sensitive names.
            For example, if you specify the values as xyZ and Abc, the response
            will include these attributes in both parent and child objects.
          schema:
            type: array
            items:
              type: string
          example:
            - Category Image
            - Category Type
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CategoryTree"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/sku:
    get:
      tags:
        - Category
      summary: Get SKUs in a category
      description: >-
        Gets SKUs of all items belonging to a category. <br /> **Note**: <br />
        1) Categories must exist in the system to get SKUs in that category. If
        SKUs are not available in the given category ID, this endpoint returns
        an empty list.
      operationId: getCategorySKUs
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: id
          description: >-
            A 4-character system-generated category ID. Either `id` or `nodeId`
            must be specified.
          example: 6196b45b5cb04b7ce167cb46
          schema:
            type: string
        - in: query
          name: nodeId
          description:
            Numeric category ID. Either `id` or `nodeId` must be specified.
          example: 2
          schema:
            type: integer
        - $ref: "#/components/parameters/Page"
        - $ref: "#/components/parameters/Size"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/SKUPage"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/attribute:
    post:
      tags:
        - Category
      summary: Assign and unassign category attributes
      description: >-
        Category attributes let you define characteristics of categories and
        children categories. <br /> This endpoint assigns or unassigns
        attributes of a single category. The primary purpose is to assign
        attributes.
      operationId: postCategoryAttributeByID
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ModifyCategoryAttributesRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CategoryAttributes"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
    get:
      tags:
        - Category
      summary: Get assigned category attributes
      description: >-
        Gets all attributes assigned to a category. <br /> **Note**: <br /> *Get
        category* endpoint (GET /v1/category) returns categories, their
        attributes, children categories, and breadcrumb details. So, this
        endpoint is recommended if you have a category ID and only require its
        attributes.
      operationId: getCategoryAttributesByID
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: id
          description: >-
            A 24-character system-generated category ID. Either `id` or `nodeId`
            must be specified.
          example: 619a8ba6f1875f6dbcaf0521
          schema:
            type: string
        - in: query
          name: nodeId
          description:
            Numeric category ID. Either `nodeId` or `id` must be specified.
          example: 2
          schema:
            type: integer
        - in: query
          name: status
          description: >-
            Attribute status. When `id` or `nodeId` is specified along with
            `status` = `Assigned`, the response is faster because the data is
            fetched from cache. When the `status` is `Unassigned`, the data is
            fetched from the DB and the response could take longer.
          schema:
            type: string
            enum:
              - ASSIGNED
              - UNASSIGNED
            example: ASSIGNED
        - $ref: "#/components/parameters/MandatoryPage"
        - $ref: "#/components/parameters/MandatorySize"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/AttributePage"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/item-attribute:
    post:
      tags:
        - Category
      summary: Assign and unassign item attributes
      description: >-
        Categories are used to segregate and group items. You can specify
        `mandatory` and `optional` attributes that all items within that
        category must have. Attributes are used to store structured information
        about items. <br /> Use this endpoint to create and manage item
        attributes for the specified category.
      operationId: postCategoryItemibuteByID
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ModifyCategoryItemAttributesRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CategoryItemAttributes"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
    get:
      tags:
        - Category
      summary: Get assigned item attributes
      description: >-
        Gets all the item attributes for the specified category. <br />
        **Note**: Items may also inherit item attributes from parent categories.
      operationId: getCategoryItemAttributes
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: id
          description: >-
            A 24-character system-generated category ID. `id` and `nodeId` are
            the two identifiers of a category. <br /> **Note**: If `id` is
            specified, `status` must be specified as well.
          example: 6196b45b5cb04b7ce167cb46
          schema:
            type: string
        - in: query
          name: nodeId
          description: >-
            Numeric category ID. `id` and `nodeId` are the two identifiers of a
            category. <br /> **Note**: If `nodeId` is specified, `status` must
            be specified as well.
          example: 25
          schema:
            type: number
        - in: query
          name: status
          description: >-
            Status of item attributes. `Assigned` indicates item attributes are
            already assigned to categories and `unassigned` indicates otherwise.
            Applicable only when `id` or `nodeId` is specified.
          schema:
            type: string
            enum:
              - ASSIGNED
              - UNASSIGNED
        - $ref: "#/components/parameters/MandatoryPage"
        - $ref: "#/components/parameters/MandatorySize"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GetCategoryItemAttributes"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/source:
    post:
      tags:
        - Category
      summary: Add and remove category source inclusions
      description: >-
        Adds and removes category sources. <br /> Primary category is the
        original catalog tree consisting of nested levels of children categories
        and is used to place items where they belong. Alternate categories are
        dynamic and populated from the Primary category, which is the original
        source of items. Source for an Alternate category points to a Primary
        category, and makes all items in the Primary category appear within the
        Alternate category; it behaves like a symlink.
      operationId: modifyCategoriesNodeSources
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ModifyNodeSourcesRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/NodeSourcesAndExclusions"
        "400":
          description: client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
    get:
      tags:
        - Category
      summary: Get category source inclusions
      description: >-
        Gets all the available category sources. <br /> Items are created under
        the Primary category, and Alternate categories are created to export
        alternate organizations of the Primary category. So, the Primary
        category is the source of items that appear in Alternate categories. The
        category sources are Primary categories that can be used as item sources
        in Alternate categories. Sources behave similar to symlinks.
      operationId: getCategoriesNodeSources
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: id
          description: >-
            A 24-character system-generated category ID. `id` and `nodeId` are
            the two identifiers of a category and one of them must be specified.
          schema:
            type: string
          example: 6170135a49b4af38190970fe
        - in: query
          name: nodeId
          description: >-
            Numeric category ID. `id` and `nodeId` are the two identifiers of a
            category and one of them must be specified.
          schema:
            type: number
          example: 12
        - in: query
          name: status
          description: >-
            Status of Category source. If omitted, 'ASSIGNED' status is used as
            default.
          schema:
            type: string
            enum:
              - ASSIGNED
              - UNASSIGNED
            example: ASSIGNED
        - $ref: "#/components/parameters/MandatoryPage"
        - $ref: "#/components/parameters/MandatorySize"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/NodeSources"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/source/exclusion:
    post:
      tags:
        - Category
      summary: Add and remove category source exclusions
      description: >-
        Adds and removes exclusions for category source, by ID. For example, a
        category source `Electronics` has Laptop, Mobile, and Tablet as children
        categories. It's possible to exclude Tablet using this endpoint, so that
        it does not appear for shoppers.
      operationId: modifyCategoriesNodeSourceExclusions
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/NodeSourcesAndExclusionsRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/NodeSourcesAndExclusions"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
    get:
      tags:
        - Category
      summary: Get category source exclusions
      description: Gets available exclusions applied to a category source.
      operationId: getCategoriesNodeSourceExclusions
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: id
          description: >-
            A 24-character system-generated category ID. `id` and `nodeId` are
            the two identifiers of a category and one of them must be specified.
          schema:
            type: string
        - in: query
          name: nodeId
          description: >-
            Numeric category ID. `id` and `nodeId` are the two identifiers of a
            category and one of them must be specified.
          schema:
            type: number
        - in: query
          name: status
          description: >-
            Status of category source. <br /> **Note**: If omitted, 'ASSIGNED'
            status is used by default.
          schema:
            type: string
            enum:
              - ASSIGNED
              - UNASSIGNED
            example: ASSIGNED
        - $ref: "#/components/parameters/MandatoryPage"
        - $ref: "#/components/parameters/MandatorySize"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/NodeSourceExclusions"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/item-attribute/condition:
    post:
      tags:
        - Category
      summary: Add and remove item attribute conditions
      description: >-
        Adds conditions for item attributes so that items can be filtered based
        on these conditions, from an Alternate category. <br /> For example, a
        Primary category called **Chairs** has three chairs of different
        materials. An Alternate category called **Wooden Chairs** with Primary
        category **Chairs** as source will list all the three chairs. Through
        this endpoint you can add a 'item attribute condition' to filter chairs
        made of wood from **Wooden Chairs**. Another example: Using this
        endpoint, you can combine categories and list items on sale (where sale
        attribute is true).
      operationId: postCategoryItemAttributeByID
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/CategoryItemAttributeConditionsRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CategoryItemAttributeConditions"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
    get:
      tags:
        - Category
      summary: Get item attribute conditions
      description: >-
        You can filter items from Alternate categories based on the conditions
        set using the POST /v1/category/item-attribute/condition endpoint. <br
        /> **Note**: Items may inherit conditions from parent category as well.
      operationId: getCategoryItemAttributesCondition
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: id
          description: >-
            A 24-character system-generated category ID. `id` and `nodeId` are
            the two identifiers of a category, and one of them must be
            specified.
          example: 6196b45b5cb04b7ce167cb46
          schema:
            type: string
        - in: query
          name: nodeId
          description: >-
            Numeric category ID. `id` and `nodeId` are the two identifiers of a
            category, and one of them must be specified.
          example: 25
          schema:
            type: number
        - in: query
          name: status
          description: Status of item attribute
          schema:
            type: string
            enum:
              - ASSIGNED
              - UNASSIGNED
            example: ASSIGNED
        - $ref: "#/components/parameters/MandatoryPage"
        - $ref: "#/components/parameters/MandatorySize"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GetCategoryItemAttributeConditions"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/bulk/upsert:
    post:
      tags:
        - Category
      summary: Create or update multiple categories or collections
      description: >-
        With endpoint, you can create or update up to 20 categories and
        collections, along with their children. It is particularly useful when
        dealing with complex organization structures. <br /> **Note**: <br /> 1)
        `parentNodeName` is a breadcrumb string of parent having delimeter as
        **->** <br /> 2) **PRIMARY** is the root category (level 0) name. To
        create root categories or children of PRIMARY root category, pass
        **PRIMARY** as `parentNodeName` parameter. For collections, the
        collection name is the root, followed by its children with delimeter <br
        /> 3) If a category name already exists as a parent category, use this
        endpoint to update the existing category. Otherwise, it creates a new
        category under the given parent.
      operationId: postBulkUpsertCategories
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/BulkUpsertCategory"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/BulkUpsertCategoryResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/find:
    post:
      tags:
        - Category
      summary: Find categories
      description: >-
        Using this endpoint, you can search for categories and collections based
        on status, type, or category attributes. You will get a paginated
        response, which you can fine tune by specifying the query parameters
        `page` and `size`. <br /> Data is retrieved from the database, ensuring
        latest results.
      operationId: findCategories
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/findCategoryRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/CategoryPage"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/bulk/category-attribute:
    post:
      tags:
        - Category
      summary: Manage category attributes for multiple categories or collections
      description: >-
        With this endpoint, you can efficiently assign and unassign category
        attributes to specified categories and collections. You can assign or
        unassign up to 10 category attributes simultaneously. For example, you
        can assign category attributes, such as material or color, to all
        clothing categories, such as dresses and shirts.
      operationId: manageCategoryAttributes
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/manageCategoryAttributesRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/manageCategoryAttributesResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/bulk/item-attribute:
    post:
      tags:
        - Category
      summary: Manage item attributes for multiple categories
      description: >-
        Use this endpoint to assign and unassign item attributes to specified
        categories. You can assign or unassign up to 10 item attributes
        simultaneously.
      operationId: manageItemAttributes
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/manageItemAttributesRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/manageItemAttributesResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/bulk/insert:
    post:
      tags:
        - Product
      summary: Create items and bundles
      description: >-
        Creates multiple items or bundles along with their attributes. In
        addition, this endpoint supports data validation to ensure accuracy and
        consistency. <br /> **Note**: <br /> 1) As a prerequisite category and
        attributes must be created beforehand. <br /> 2) To add an item variant,
        parentSku must be additionally specified. <br /> 3) An item is assigned
        to only one category but it can be fetched from Alternate categories.
        <br /> 4) Up to 50 items or bundles can be added.
      operationId: createProducts
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ProductCreate"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProductResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "422":
          description: Failing items
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProductModifyError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/bulk/update:
    post:
      tags:
        - Product
      summary: Update items and bundles
      description: >-
        With this endpoint, you can update multiple items or bundles, along with
        their attributes. <br /> **Note**: <br /> 1) You can update up to 50
        items or bundles. <br /> 2) By specifying the attribute `value` as NULL,
        a reserved keyword, you can remove the existing attribute value.
      operationId: updateProducts
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ProductUpdate"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProductResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "422":
          description: Failing items
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProductModifyError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/bulk/upsert:
    post:
      tags:
        - Product
      summary: Upsert items and bundles
      description: >-
        With this endpoint, you can create or update items or bundles along with
        their attributes. <br /> **Note**: <br /> 1) If the SKU already exists,
        then the given item or bundle is updated. Otherwise, a new item or
        bundle is created with that SKU. <br /> 2) You can add or update up to
        50 items or bundles. <br /> 3) By specifying the attribute `value` as
        NULL, a reserved keyword, you can remove the existing attribute value.
      operationId: upsertProducts
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/ProductCreate"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProductResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "422":
          description: Failing items
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProductModifyError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/bundle/update:
    post:
      tags:
        - Product
      summary: Update items in bundle
      description:
        Updates bundle by adding or removing items and adjusting quantities.
      operationId: updateBundles
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/BundleUpdateRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/BundleUpdateResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product:
    get:
      tags:
        - Product
      summary: Get items and children items
      description: >-
        Items can be individual items or a bundle of items. This endpoints
        allows you to retrieve items - individual items and bundles, along with
        their attributes, children items and their details. <br /> **Note**: <br
        /> 1) Optional filter parameters can be passed in as query to narrow
        down the search results. <br /> 2) This API will only return the count
        and details of Parent SKU and not its variants
      operationId: getProducts
      security:
        - authorization: []
      parameters:
        - name: x-site-context
          in: header
          description: >-
            The `x-site-context` header is a JSON object that contains
            information about the source you wish to pull from. The mandatory
            `account` is the 24 character identifier found in Copilot. The
            `channel` (Sales channel ID), `stage` (environment name), and `date`
            attributes can be used to further narrow the scope of your data
            source.
          required: true
          schema:
            type: string
            example: >-
              {"date": "2023-01-01T00:00:00.000Z", "channel": 12, "account":
              "1234abcd5678efgh9ijklmno","stage":"production"}
        - in: query
          name: skus
          description: >-
            Stock Keeping Units (SKUs). <br /> **Note**: Either `skus` or
            `itemIds` can be used to get specific items. If they are omitted,
            all items are returned in a paginated response. Using the query
            parameters `page` and `size`, you can narrow down the search
            results.
          schema:
            type: array
            items:
              type: string
          example:
            - BUNDLE-01
            - BUNDLE-02
          explode: false
        - in: query
          name: itemIds
          description: >-
            Item IDs. Applicable only when `skus` are omitted. <br /> **Note**:
            Either `skus` or `itemIds` can be used to get specific items. If
            they are omitted, all items are returned in a paginated response.
            Using the query parameters `page` and `size`, you can narrow down
            the search results.
          schema:
            type: array
            items:
              type: number
          example:
            - 4
            - 5
          explode: false
        - in: query
          name: page
          description: >-
            Page number to be retrieved. Applicable only in a paginated response
            and always paired with `size`.
          schema:
            type: number
            example: 1
        - in: query
          name: size
          description: >-
            Number of records per page. Applicable only in a paginated response
            and always paired with `page`.
          schema:
            type: number
            example: 10
        - in: query
          name: status
          description: >-
            Item status. <br /> **Note**: <br /> 1) Returns a paginated
            response. <br /> 2) When used as the only criteria, must be paired
            with `size` and `page` to narrow down the search results.
          schema:
            type: string
            enum:
              - ACTIVE
              - INACTIVE
            example: ACTIVE
        - in: query
          name: createdAfter
          description: >-
            Lists items created after a specific date. Valid date formats are
            'YYYY/MM/DD', 'YYYY-MM-DDTHH:mm:ss.SSSZ'. <br /> **Note**: <br /> 1)
            Applicable only when `skus` and `itemIds` are omitted. <br /> 2)
            Returns paginated response. <br /> 3) Must be paired with `size` and
            `page` to narrow down the search results.
          schema:
            type: string
            example: "2021-05-28T16:36:50.055Z"
        - in: query
          name: createdBefore
          description: >-
            Lists items created before a specific date. Valid date formats are
            'YYYY/MM/DD', 'YYYY-MM-DDTHH:mm:ss.SSSZ'. <br /> **Note**: <br /> 1)
            Applicable only when `skus` and `itemIds` are omitted. <br /> 2)
            Returns paginated response. <br /> 3) Must be paired with `size` and
            `page` to narrow down the search results.
          schema:
            type: string
            example: "2021-05-28T16:36:50.055Z"
        - in: query
          name: modifiedAfter
          description: >-
            Lists items modified after a specific date. Valid date formats are
            'YYYY/MM/DD', 'YYYY-MM-DDTHH:mm:ss.SSSZ'. <br /> **Note**: <br /> 1)
            Applicable only when `skus` or `itemIds` are omitted. <br /> 2)
            Returns paginated response. <br /> 3) Must be paired with `size` and
            `page` to narrow down the search results.
          schema:
            type: string
            example: "2021-05-28T16:36:50.055Z"
        - in: query
          name: modifiedBefore
          description: >-
            Gets items modified before a specific date. Valid date formats are
            'YYYY/MM/DD', 'YYYY-MM-DDTHH:mm:ss.SSSZ'. <br /> **Note**: <br /> 1)
            Applicable only when `skus` and `itemIds` are omitted. <br /> 2)
            Returns paginated response. <br /> 3) Must be paired with `size` and
            `page` to narrow down the search results.
          schema:
            type: string
            example: "2021-05-28T16:36:50.055Z"
        - in: query
          name: onlyIncludeAttributes
          description: >-
            Attributes are included based on their exact, case-sensitive names.
            For example, if you specify the values as xyZ and Abc, the response
            will include these attributes in both parent and child objects.
          schema:
            type: array
            items:
              type: string
          example:
            - Image
            - Title
        - in: query
          name: onlyExcludeAttributes
          description: >-
            Attributes are excluded based on their exact, case-sensitive names.
            For example, if you specify the values as xyZ and Abc, the response
            will exclude these attributes from both parent and child objects.
            <br /> **Note**: When both `onlyIncludeAttributes` and
            `onlyExcludeAttributes` are used, the `onlyIncludeAttributes` takes
            precedence. As a result, attributes are first filtered based on
            `onlyIncludeAttributes`, and then `onlyExcludeAttributes` is applied
            to further refine the selection.
          schema:
            type: array
            items:
              type: string
          example:
            - Image
            - Title
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                oneOf:
                  - $ref: "#/components/schemas/ItemProductsResponse"
                  - $ref: "#/components/schemas/BundleProductsResponse"
                  - $ref: "#/components/schemas/NoProductsResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v2/product:
    get:
      tags:
        - Product
      summary: Get items and limited children items
      description: >-
        Gets items (single item or bundles) by `skus` or parent `skus`. When a
        parent SKU is sent as query parameter, you'll get children items of
        those SKUs. When `parentSKU` is not specified, children items are not
        retrieved. Optionally, `page` and `size` can be used as query
        parameters. **Note**: <br /> 1) `status` and `date` query parameters
        works only with pagination when `parentSku` is omitted. Separate
        responses are shown for bundle and product.<br /> 2) when `parentSku` is
        passed as request parameter, it will only return the paginated response
        of children of `parentSKU`.
      operationId: getProductsV2
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: skus
          description: >-
            Stock Keeping Units (SKUs). <br /> **Note**: Either `skus` or
            `itemIds` can be used to get specific items. If they are omitted,
            all items are returned in a paginated response. Using the query
            parameters `page` and `size`, you can narrow down the search
            results.
          schema:
            type: string
          example: BUNDLE-01
        - in: query
          name: page
          description: >-
            Page number to be retrieved. Applicable only in a paginated response
            and always paired with `size`.
          schema:
            type: number
            example: 1
        - in: query
          name: size
          description: >-
            Number of records per page. Applicable only in a paginated response
            and always paired with `page`.
          schema:
            type: number
            example: 10
        - in: query
          name: status
          description: >-
            Item status. <br /> **Note**: <br /> 1) Returns a paginated
            response. <br /> 2) When used as the only criteria, must be paired
            with `size` and `page` to narrow down the search results.
          schema:
            type: string
            enum:
              - ACTIVE
              - INACTIVE
            example: ACTIVE
        - in: query
          name: type
          description:
            "Item type. **Note**: Set page and size to use this filter."
          schema:
            type: string
            enum:
              - ITEM
              - BUNDLE
        - in: query
          name: createdAfter
          description: >-
            Items created after a specific date. Valid date formats are
            'YYYY/MM/DD', 'YYYY-MM-DDTHH:mm:ss.SSSZ'. <br /> **Note**: <br /> 1)
            Applicable only when `skus` and `itemIds` are omitted. <br /> 2)
            Returns paginated response. <br /> 3) Must be paired with `size` and
            `page` to narrow down the search results.
          schema:
            type: string
            example: "2021-05-28T16:36:50.055Z"
        - in: query
          name: createdBefore
          description: >-
            Items created before a specific date. Valid date formats are
            'YYYY/MM/DD', 'YYYY-MM-DDTHH:mm:ss.SSSZ'. <br /> **Note**: <br /> 1)
            Applicable only when `skus` and `itemIds` are omitted. <br /> 2)
            Returns paginated response. <br /> 3) Must be paired with `size` and
            `page` narrow down the search results.
          schema:
            type: string
            example: "2021-05-28T16:36:50.055Z"
        - in: query
          name: modifiedAfter
          description: >-
            Items modified after a specific date. Valid date formats are
            'YYYY/MM/DD', 'YYYY-MM-DDTHH:mm:ss.SSSZ'. <br /> **Note**: <br /> 1)
            Applicable only when `skus` or `itemIds` are omitted. <br /> 2)
            Returns paginated response. <br /> 3) Must be paired with `size` and
            `page` to narrow down the search results.
          schema:
            type: string
            example: "2021-05-28T16:36:50.055Z"
        - in: query
          name: modifiedBefore
          description: >-
            Items modified before a specific date. Valid date formats are
            'YYYY/MM/DD', 'YYYY-MM-DDTHH:mm:ss.SSSZ'. <br /> **Note**: <br /> 1)
            Applicable only when `skus` and `itemIds` are omitted. <br /> 2)
            Returns paginated response. <br /> 3) Must be paired with `size` and
            `page` to narrow down the search results.
          schema:
            type: string
            example: "2021-05-28T16:36:50.055Z"
        - in: query
          name: parentSku
          description: >-
            Parent SKU to get its children items. <br /> **Note** <br /> 1) To
            get a p paginates response, optionally, `size` and `page` can be
            used as query parameters. When they are omitted, this endpoint
            returns all children. <br /> 2) Only `page` and `size` are supported
            with this query parameter, to narrow down the search results.
          schema:
            type: string
            example: parent123
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                oneOf:
                  - $ref: "#/components/schemas/ItemProductsV2Response"
                  - $ref: "#/components/schemas/BundleProductsResponse"
                  - $ref: "#/components/schemas/NoProductsResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/search:
    get:
      tags:
        - Product
      summary: Find items
      description: >-
        Finds items - both individual items and bundles. You will get a
        paginagted response, which you can narrow down using filter parameters,
        including `page` and `size`.
      operationId: productSearch
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: keyword
          description: Keywords related to SKU or title
          schema:
            type: string
            example: MOBO-1024
        - in: query
          name: skus
          description: >-
            Searches for items based on SKU. <br /> **Note**: If omitted, all
            items are retrieved. <br /> Applicable only when `keyword` is
            omitted.
          schema:
            type: array
            items:
              type: string
          example:
            - MOBO-1024
            - MOBO-1025
          explode: false
        - in: query
          name: itemIds
          description: >-
            Item IDs. <br /> **Note**: If omitted, all items are retrieved <br
            /> Applicable only when `keyword` and `skus` are omitted.
          schema:
            type: array
            items:
              type: string
          example:
            - 4
            - 5
          explode: false
        - in: query
          name: page
          description: Page number to be retrieved.
          schema:
            type: number
          example: 10
        - in: query
          name: size
          description: >-
            Number of records per page. <br />**Note**: 1) Always paired with
            `page`. <br />2) Applicable only in a paginated response.
          schema:
            type: integer
          example: 10
        - in: query
          name: type
          description: Item type
          schema:
            type: string
            enum:
              - ITEM
              - BUNDLE
              - ALL
            example: ITEM
        - in: query
          name: allAttributes
          description: >-
            true: Gets all attributes. false: Gets only the mapped attributes.
            <br /> **Note**: Always clubbed with `page` and `size`. When they
            are not specified, you will get up to 10 records.
          schema:
            type: boolean
            example: true
        - in: query
          name: excludeChildren
          description:
            "true: Excludes children items <br /> false: Includes children items"
          schema:
            type: boolean
            example: false
        - in: query
          name: onlyChildren
          description:
            "true: Excludes parent items <br /> false: Includes parent items"
          schema:
            type: boolean
            example: true
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                oneOf:
                  - $ref: "#/components/schemas/ItemProductSearchResponse"
                  - $ref: "#/components/schemas/BundleProductSearchResponse"
                  - $ref: "#/components/schemas/NoProductsResponse"
        "400":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/attribute:
    get:
      tags:
        - Product
      summary: Get item attributes
      description: >-
        Item attributes define characteristics of an item. For example, item
        name, its identifiers, and description are the common attributes of any
        item. Attributes are key-value pairs (color: red) that hold information
        for each property of an item. <br /> This endpoint gets all attributes
        of an item, by SKU or itemId. <br /> **Note**: The *Get item* (GET
        /v1/product) gets item details and their attribute. So, this endpoint is
        recommended when you have the item SKU or item ID, and only require its
        attributes.
      operationId: getProductAttribute
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: query
          name: sku
          description: >-
            Stock Keeping Unit (SKU) of item. <br /> **Note**: If omitted
            `itemId` becomes mandatory.
          schema:
            type: string
            example: MOBO-1024
        - in: query
          name: itemId
          description:
            "Item ID. <br /> **Note**: If omitted `sku` becomes mandatory."
          schema:
            type: number
            example: 3
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProductAttributePage"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/attribute/bulk:
    post:
      tags:
        - Attributes
      summary: Create, update and delete category attributes
      description: >-
        Creates, updates and deletes category attributes. The primary purpose is
        to create and edit the attributes to be assigned to categories. <br />
        **Note**: They are generic category attributes and not specific to a
        category.
      operationId: postCategoryAttributeBulk
      security:
        - authorization: []
        - api_key: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/BulkAttributeRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/BulkAttributeResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/attribute/bulk:
    post:
      tags:
        - Attributes
      summary: Create update and delete item attributes
      description: >-
        Item attributes allow you to define specific characteristics for items.
        Common examples of attributes include size, color, and material.
        Well-defined attributes are important because they enable item discovery
        and make catalog management easier. <br /> This endpoint creates and
        updates item attributes to be assigned later. <br /> **Note**: <br /> 1)
        You can add and manage unlimited attributes for your items. Once they
        are created, they appear as a selectable option on product pages. <br />
        2) In addition, you can assign attributes to items on an individual
        level or in bulk.
      operationId: postProductAttributeBulk
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/BulkProductAttributeRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/BulkAttributeResponse"
        "400":
          description: Client error.
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/attribute-group:
    post:
      tags:
        - Attributes
      summary: Create, update and delete attribute groups
      description: >-
        Using attribute groups, you can group various attributes together to
        make it easier to manage large volume of item information. <br /> Use
        this endpoint to create, update, or delete attribute groups. <br />
        **Note**: In the context of Product Catalog, attribute group is optional.
        When created, it must have at least one attribute.
      operationId: modifyAttributeGroups
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/AttributeGroupRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/AttributeGroupResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/attribute-group/search:
    post:
      tags:
        - Attributes
      summary: Find attribute groups
      description: >-
        Find attribute groups based on the given search criteria. You will get a
        paginated response, which you can narrow down using filter criteria such
        as `page` and `size`.
      operationId: searchAttributeGroups
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/AttributeGroupSearchRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/AttributeGroupSearchResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/attribute/mapping/search:
    post:
      tags:
        - Attributes
      summary: Find attribute mapping
      description: >-
        Searches for attribute mapping based on the given search criteria. You
        will get a paginated response, which you can narrow down using filter
        criteria such as `page` and `size`.
      operationId: searchAttributeMappings
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/AttributeMappingSearch"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/AttributeMappingPaginationResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/attribute/mapping:
    post:
      tags:
        - Attributes
      summary: Create and Update attribute mappings
      description: >-
        Set your attribute mapping to begin configuring your catalog. You can
        update the mappings only if there are no SKUs present in the catalog.
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      operationId: modifyAttributeMappings
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/AttributeMappingModify"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/AttributeMappingResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/bulk/template:
    get:
      tags:
        - Bulk Import
      summary: Generate CSV template for categories
      description: Generates CSV template to bulk upload categories.
      operationId: generateCSVfileForCategory
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      responses:
        "200":
          description: OK
          content:
            application/csv:
              schema:
                type: string
                format: binary
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/upload-url:
    post:
      tags:
        - Bulk Import
      summary: Generate S3 bucket URL for categories import
      description: >-
        Generates S3 bucket URL to upload categories using CSV file. Follow
        these steps to bulk upload categories using CSV: <br /> 1) Download the
        template using *GET /api-category/v1/category/bulk/template* <br /> 2)
        Upload the URL using *POST /api-category/v1/upload-url*<br /> 3) Open
        the URL from the response of the above endpoint (*POST
        /api-category/v1/upload-url*), change the method to PUT, update
        **binary** in the requestBody type to view the select file option and
        upload a CSV from local system <br /> 4) You may check the status using
        this endpoint *GET /api-category/v1/category/bulk/file/:fileId/status*
      operationId: generateS3urlForCategory
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/GetS3URLRequestUsingOnlyFileName"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GetS3URLResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/file/search:
    post:
      tags:
        - Bulk Import
      summary: Get imported files for categories
      description: >-
        Gets a list of files used for importing categories, along with their
        current statuses. You will get a paginated response, which you can
        narrow down using filter criteria such as `page` and `size`.
      operationId: fileSearchForCategories
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/FileSearchRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/FilePaginationResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-category/v1/category/bulk/file/{fileId}/status:
    get:
      tags:
        - Bulk Import
      summary: Get file upload status
      description: Gets file upload status by file ID.
      operationId: getFileStatusForCategories
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: path
          name: fileId
          description: 24-character system-generated file ID
          schema:
            type: string
          required: true
          example: 626c3c28e041b10009810b21
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                oneOf:
                  - $ref: "#/components/schemas/UploadFileStatusResponse"
                  - $ref: "#/components/schemas/UploadFileStatusNoItemResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/bulk/template/{accountId}/{nodeId}:
    get:
      tags:
        - Bulk Import
      summary: Generate CSV template file for items
      description:
        Generates CSV template to upload items for a specific category.
      operationId: generateCSVfile
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: path
          name: accountId
          description: Account ID
          schema:
            type: string
          required: true
        - in: path
          name: nodeId
          description: A 24-character system-generated category ID
          schema:
            type: string
          required: true
          example: 6131f771d4a7fa4314e45ebd
      responses:
        "200":
          description: OK
          content:
            application/csv:
              schema:
                type: string
                format: binary
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/upload-url:
    post:
      tags:
        - Bulk Import
      summary: Generate S3 bucket URL for item import
      description: >-
        Generates S3 bucket URL to upload items using CSV file. Follow these
        steps for bulk upload using CSV: <br /> 1) Download the template using
        *GET /api-product/v1/product/bulk/template/:accountid/:nodeId* <br /> 2)
        Upload the url using *POST /api-product/v1/upload-url*<br /> 3) Open the
        URL from the response of the above endpoint (*POST
        /api-product/v1/upload-url*), change the method to PUT, update
        **binary** in the requestBody type to view the select file option and
        upload a CSV from local system <br /> 4) You may check the status using
        this endpoint *GET /api-product/v1/product/bulk/file/:fileId/status*
      operationId: generateS3url
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/GetS3URLRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GetS3URLResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/file/search:
    post:
      tags:
        - Bulk Import
      summary: Get imported files for items
      description: >-
        Gets a list of files used to import items, along with their current
        statuses. You will get a paginated response, which you can narrow down
        using filter criteria such as `page` and `size`.
      operationId: fileSearch
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/FileSearchRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/FilePaginationResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/bulk/template/bundle/{accountId}/{nodeId}:
    get:
      tags:
        - Bulk Import
      summary: Generate CSV template for bundles
      description:
        Generates CSV template to upload bundles for a specific category.
      operationId: generateItemBundleCSVfile
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: path
          name: accountId
          description: Account ID
          schema:
            type: string
          required: true
        - in: path
          name: nodeId
          description: A 24-character system-generated category ID
          schema:
            type: string
          required: true
          example: 6131f771d4a7fa4314e45ebd
      responses:
        "200":
          description: OK
          content:
            application/csv:
              schema:
                type: string
                format: binary
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/upload-url/bundle:
    post:
      tags:
        - Bulk Import
      summary: Generate S3 bucket URL for bundle import
      description: Generates S3 bucket URL to upload item bundles using CSV file
      operationId: generateItemBundleS3url
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/GetS3URLBundleRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GetS3URLBundleResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/file/bundle/search:
    post:
      tags:
        - Bulk Import
      summary: Get imported files for bundles
      description: >-
        Gets a list of files used to import bundles, along with their current
        statuses. You will get a paginated response, which you can narrow down
        using filter criteria such as `page` and `size`.
      operationId: ItemBundleFileSearch
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/FileSearchRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/FilePaginationResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/bulk/template/attribute:
    get:
      tags:
        - Bulk Import
      summary: Generate CSV template for item attributes
      description: "Generates CSV template to upload item attributes. "
      operationId: generateItemAttributeCSVfile
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      responses:
        "200":
          description: OK
          content:
            application/csv:
              schema:
                type: string
                format: binary
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/upload-url/attribute:
    post:
      tags:
        - Bulk Import
      summary: Generate S3 bucket URL for item attribute import
      description:
        Generates S3 bucket URL to upload item attribute using CSV file
      operationId: generateItemAttributeS3url
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/GetS3URLItemAttributeRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GetS3URLItemAttributeResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/file/attribute/search:
    post:
      tags:
        - Bulk Import
      summary: Get imported files for item attributes
      description: >-
        Gets a list of files used to import item attributes, along with their
        current statuses. You will get a paginated response, which you can
        narrow down using filter criteria such as `page` and `size`.
      operationId: ItemAttributeFileSearch
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/FileSearchRequest"
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/FilePaginationResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
  /api-product/v1/product/bulk/file/{fileId}/status:
    get:
      tags:
        - Bulk Import
      summary: Get file upload status
      description: Gets file upload status by using file ID
      operationId: getFileStatus
      security:
        - authorization: []
      parameters:
        - $ref: "#/components/parameters/xSiteContent"
        - in: path
          name: fileId
          description: A 24-character system-generated file ID
          schema:
            type: string
          required: true
          example: 626c3c28e041b10009810b21
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                oneOf:
                  - $ref: "#/components/schemas/UploadFileStatusResponse"
                  - $ref: "#/components/schemas/UploadFileStatusNoItemResponse"
        "400":
          description: Client error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ClientError"
        "500":
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ServerError"
components:
  securitySchemes:
    api_key:
      type: apiKey
      name: x-api-key
      description: >-
        The `x-api-key` enables you to access the fabric API without
        `Authorization`. You must request fabric Inc to obtain this key.<br
        />Authorization` header is required if `x-api-key` is omitted.
      in: header
    authorization:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description:
        S2S access token (JWT) from fabric Identity service (during Login)
  schemas:
    BulkAttributeRequest:
      type: array
      items:
        type: object
        required:
          - type
          - name
          - action
        properties:
          action:
            type: string
            enum:
              - CREATE
              - UPDATE
              - DELETE
            example: UPDATE
            description: >-
              Action type. <br /> **Note**: <br /> 1) Attribute ID is required
              only for `UPDATE` and `DELETE` actions (not for CREATE). <br /> 2)
              `CREATE` action replaces any existing category attribute with the
              same name.
          id:
            description: A 24-character system-generated attribute ID
            example: 61ba11691a29d52cb2842541
            type: string
          name:
            description: Attribute name
            example: weight
            type: string
          description:
            description:
              Accurate description of the attribute and what it represents
            example: Item weight, in KG
            type: string
          type:
            description: Supported attribute types for the attribute
            example: INTEGER
            type: string
            enum:
              - TEXT
              - BOOLEAN
              - SERIAL
              - DECIMAL
              - INTEGER
              - DATETIME
              - OPTIONS
          textSubType:
            description: Conditionally required for `TEXT` attribute type
            example: HTML
            type: string
            enum:
              - SMALL_TEXT
              - TEXT_AREA
              - HTML
          serialStart:
            description: >-
              Conditionally required to indicate the starting value of `SERIAL`
              attribute type. When enabled, the subsequent attribute values
              increment by 1.
            example: 1000
            type: number
          optionsType:
            description: >-
              Conditionally required to indicate the selectable values for
              `OPTIONS` attribute type
            type: string
            example: DATETIME
            enum:
              - TEXT
              - BOOLEAN
              - DECIMAL
              - INTEGER
              - DATETIME
          format:
            description: >-
              Attribute format. Currently used only for `DATETIME` attribute
              type.
            type: string
            example: YYYY-MM-DD
          formula:
            description: >-
              JavaScript expression to dynamically compute the attribute value.
              The data type returned by this expression must match the
              attribute's data type. <br /> **Note**: When this is provided,
              `validation` is ignored.
            type: string
            example: "`${item.weightValue} ${item.weightUnit}`"
          validation:
[...]
